#include<bits/stdc++.h>

using namespace std;
#define int long long

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    int n,k;
    cin >> n >> k;
    vector<int> a(n);
    for(int i = 0; i < n; ++i) cin >> a[i];
    int mx = a[0];
    int ans = 0;
    for(int i = 1; i < n; ++i){
        ans = max(ans,mx + a[i] + i + 1);
    }
    cout << ans << '\n';
    return 0;
}
